diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
index 06d0e3f6d5..0c1e03f044 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
@@ -3142,115 +3578,34 @@ t4_handle_fw_msg(struct sge_iq *iq, const struct rss_header *rss)
 	}
 }
 
-static int
-t4_eth_rx(struct sge_iq *iq, const struct rss_header *rss, mblk_t *m)
-{
-	bool csum_ok;
-	uint16_t err_vec;
-	struct sge_rxq *rxq = (void *)iq;
-	struct mblk_pair chain = {0};
-	struct adapter *sc = iq->adapter;
-	const struct cpl_rx_pkt *cpl = t4_rss_payload(rss);
-
-	m->b_rptr += sc->sge.pktshift;
-
-	/* Compressed error vector is enabled for T6 only */
-	if (sc->params.tp.rx_pkt_encap)
-		/* It is enabled only in T6 config file */
-		err_vec = G_T6_COMPR_RXERR_VEC(ntohs(cpl->err_vec));
-	else
-		err_vec = ntohs(cpl->err_vec);
-
-	csum_ok = cpl->csum_calc && !err_vec;
-	/* TODO: what about cpl->ip_frag? */
-	if (csum_ok && !cpl->ip_frag) {
-		mac_hcksum_set(m, 0, 0, 0, 0xffff,
-		    HCK_FULLCKSUM_OK | HCK_FULLCKSUM |
-		    HCK_IPV4_HDRCKSUM_OK);
-		rxq->rxcsum++;
-	}
-
-	/* Add to the chain that we'll send up */
-	if (chain.head != NULL)
-		chain.tail->b_next = m;
-	else
-		chain.head = m;
-	chain.tail = m;
-
-	t4_mac_rx(rxq->port, rxq, chain.head);
-
-	rxq->rxpkts++;
-	rxq->rxbytes  += be16_to_cpu(cpl->len);
-	return (0);
-}
-
-#define	FL_HW_IDX(idx)	((idx) >> 3)
-
-static inline void
-ring_fl_db(struct adapter *sc, struct sge_fl *fl)
+static void
+t4_fl_ring_db(struct sge_fl *fl)
 {
-	int desc_start, desc_last, ndesc;
-	uint32_t v = sc->params.arch.sge_fl_db;
-
-	ndesc = FL_HW_IDX(fl->pending);
-
-	/* Hold back one credit if pidx = cidx */
-	if (FL_HW_IDX(fl->pidx) == FL_HW_IDX(fl->cidx))
-		ndesc--;
-
-	/*
-	 * There are chances of ndesc modified above (to avoid pidx = cidx).
-	 * If there is nothing to post, return.
-	 */
-	if (ndesc <= 0)
-		return;
-
-	desc_last = FL_HW_IDX(fl->pidx);
+	struct adapter *sc = t4_fl_to_iq(fl)->tsi_adapter;
+	t4_sge_eq_t *eq = &fl->eq;
 
-	if (fl->pidx < fl->pending) {
-		/* There was a wrap */
-		desc_start = FL_HW_IDX(fl->pidx + fl->cap - fl->pending);
-
-		/* From desc_start to the end of list */
-		(void) ddi_dma_sync(fl->dhdl, desc_start * RX_FL_ESIZE, 0,
-		    DDI_DMA_SYNC_FORDEV);
-
-		/* From start of list to the desc_last */
-		if (desc_last != 0)
-			(void) ddi_dma_sync(fl->dhdl, 0, desc_last *
-			    RX_FL_ESIZE, DDI_DMA_SYNC_FORDEV);
-	} else {
-		/* There was no wrap, sync from start_desc to last_desc */
-		desc_start = FL_HW_IDX(fl->pidx - fl->pending);
-		(void) ddi_dma_sync(fl->dhdl, desc_start * RX_FL_ESIZE,
-		    ndesc * RX_FL_ESIZE, DDI_DMA_SYNC_FORDEV);
-	}
+	EQ_LOCK_ASSERT_OWNED(eq);
 
-	if (t4_cver_eq(sc, CHELSIO_T4))
-		v |= V_PIDX(ndesc);
-	else
-		v |= V_PIDX_T5(ndesc);
-	v |= V_QID(fl->cntxt_id) | V_PIDX(ndesc);
+	(void) ddi_dma_sync(eq->tse_ring_dhdl, 0, 0, DDI_DMA_SYNC_FORDEV);
 
 	membar_producer();
 
-	t4_write_reg(sc, MYPF_REG(A_SGE_PF_KDOORBELL), v);
+	t4_write_reg(sc, MYPF_REG(A_SGE_PF_KDOORBELL),
+	    sc->params.arch.sge_fl_db |
+	    V_QID(eq->tse_cntxt_id) |
+	    V_PIDX(eq->tse_pending));
 
-	/*
-	 * Update pending count:
-	 * Deduct the number of descriptors posted
-	 */
-	fl->pending -= ndesc * 8;
+	eq->tse_pending = 0;
 }
 
 static void
-t4_sge_egr_update(struct sge_iq *iq, const struct rss_header *rss)
+t4_sge_egr_update(t4_sge_iq_t *iq, const struct rss_header *rss)
 {
-	struct adapter *sc = iq->adapter;
+	struct adapter *sc = iq->tsi_adapter;
 	const struct cpl_sge_egr_update *cpl = t4_rss_payload(rss);
 	const uint_t qid = G_EGR_QID(BE_32(cpl->opcode_qid));
 	struct sge_txq *txq = (struct sge_txq *)(*t4_eqmap_slot(sc, qid));
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
 
 	/*
 	 * Get a "live" snapshot of the flags and PIDX state from the TXQ.
@@ -3260,8 +3615,8 @@ t4_sge_egr_update(struct sge_iq *iq, const struct rss_header *rss)
 	 * reclaim.
 	 */
 	membar_consumer();
-	const uint16_t live_pidx = BE_16(eq->pidx);
-	const t4_eq_flags_t live_flags = eq->flags;
+	const uint16_t live_pidx = BE_16(eq->tse_pidx);
+	const t4_eq_flags_t live_flags = eq->tse_flags;
 
 	if ((live_flags & EQ_CORKED) == 0 &&
 	    (cpl->pidx != cpl->cidx || live_pidx != cpl->cidx)) {
@@ -3272,7 +3627,7 @@ t4_sge_egr_update(struct sge_iq *iq, const struct rss_header *rss)
 		 *    allocate descriptors (or memory) while attempting to place
 		 *    a packet in the TXQ.
 		 *
-		 * 2. There are additional transmit descriptors in the EQ which
+		 * 2. There are outstanding transmit descriptors in the EQ which
 		 *    will trigger a subsequent SGE_EGR_UPDATE notification.
 		 *
 		 * When those conditions are met, it is safe to skip performing
@@ -3288,10 +3643,10 @@ t4_sge_egr_update(struct sge_iq *iq, const struct rss_header *rss)
 	bool do_mac_update = false;
 
 	TXQ_LOCK(txq);
-	(void) t4_tx_reclaim_descs(txq, eq->qsize, &freemp);
-	if (eq->flags & EQ_CORKED && eq->avail != 0) {
+	(void) t4_tx_reclaim_credits(txq, eq->tse_qsize, &freemp);
+	if (eq->tse_flags & EQ_CORKED && eq->tse_avail != 0) {
 		do_mac_update = true;
-		eq->flags &= ~EQ_CORKED;
+		eq->tse_flags &= ~EQ_CORKED;
 	}
 	TXQ_UNLOCK(txq);
 
@@ -3304,7 +3659,7 @@ t4_sge_egr_update(struct sge_iq *iq, const struct rss_header *rss)
 #define	KS_UINIT(x)	kstat_named_init(&kstatp->x, #x, KSTAT_DATA_ULONG)
 #define	KS_CINIT(x)	kstat_named_init(&kstatp->x, #x, KSTAT_DATA_CHAR)
 #define	KS_U_SET(x, y)	kstatp->x.value.ul = (y)
-#define	KS_U_FROM(x, y)	kstatp->x.value.ul = (y)->x
+#define	KS_U_FROM(x, y)	kstatp->x.value.ul = (y)->stats.x
 #define	KS_C_SET(x, ...)	\
 			(void) snprintf(kstatp->x.value.c, 16,  __VA_ARGS__)
 
@@ -3313,10 +3668,10 @@ t4_sge_egr_update(struct sge_iq *iq, const struct rss_header *rss)
  */
 struct cxgbe_port_config_kstats {
 	kstat_named_t idx;
-	kstat_named_t nrxq;
-	kstat_named_t ntxq;
-	kstat_named_t first_rxq;
-	kstat_named_t first_txq;
+	kstat_named_t rxq_count;
+	kstat_named_t txq_count;
+	kstat_named_t rxq_start;
+	kstat_named_t txq_start;
 	kstat_named_t controller;
 	kstat_named_t factory_mac_address;
 };
@@ -3360,18 +3715,18 @@ setup_port_config_kstats(struct port_info *pi)
 	kstatp = (struct cxgbe_port_config_kstats *)ksp->ks_data;
 
 	KS_UINIT(idx);
-	KS_UINIT(nrxq);
-	KS_UINIT(ntxq);
-	KS_UINIT(first_rxq);
-	KS_UINIT(first_txq);
+	KS_UINIT(rxq_count);
+	KS_UINIT(txq_count);
+	KS_UINIT(rxq_start);
+	KS_UINIT(txq_start);
 	KS_CINIT(controller);
 	KS_CINIT(factory_mac_address);
 
 	KS_U_SET(idx, pi->port_id);
-	KS_U_SET(nrxq, pi->nrxq);
-	KS_U_SET(ntxq, pi->ntxq);
-	KS_U_SET(first_rxq, pi->first_rxq);
-	KS_U_SET(first_txq, pi->first_txq);
+	KS_U_SET(rxq_count, pi->rxq_count);
+	KS_U_SET(txq_count, pi->txq_count);
+	KS_U_SET(rxq_start, pi->rxq_start);
+	KS_U_SET(txq_start, pi->txq_start);
 	KS_C_SET(controller, "%s%d", ddi_driver_name(pdip),
 	    ddi_get_instance(pdip));
 	KS_C_SET(factory_mac_address, "%02X%02X%02X%02X%02X%02X",
@@ -3492,11 +3847,10 @@ struct rxq_kstats {
 	kstat_named_t rxcsum;
 	kstat_named_t rxpkts;
 	kstat_named_t rxbytes;
-	kstat_named_t nomem;
 };
 
 static kstat_t *
-setup_rxq_kstats(struct port_info *pi, struct sge_rxq *rxq, int idx)
+setup_rxq_kstats(struct port_info *pi, struct sge_rxq *rxq, uint_t q_idx)
 {
 	struct kstat *ksp;
 	struct rxq_kstats *kstatp;
@@ -3504,14 +3858,14 @@ setup_rxq_kstats(struct port_info *pi, struct sge_rxq *rxq, int idx)
 	char str[16];
 
 	ndata = sizeof (struct rxq_kstats) / sizeof (kstat_named_t);
-	(void) snprintf(str, sizeof (str), "rxq%u", idx);
+	(void) snprintf(str, sizeof (str), "rxq%u", q_idx);
 
 	ksp = kstat_create(T4_PORT_NAME, ddi_get_instance(pi->dip), str, "rxq",
 	    KSTAT_TYPE_NAMED, ndata, 0);
 	if (ksp == NULL) {
 		cxgb_printf(pi->dip, CE_WARN,
-		    "%s: failed to initialize rxq kstats for queue %d.",
-		    __func__, idx);
+		    "%s: failed to initialize rxq kstats for queue %u.",
+		    __func__, q_idx);
 		return (NULL);
 	}
 
@@ -3520,7 +3874,6 @@ setup_rxq_kstats(struct port_info *pi, struct sge_rxq *rxq, int idx)
 	KS_UINIT(rxcsum);
 	KS_UINIT(rxpkts);
 	KS_UINIT(rxbytes);
-	KS_UINIT(nomem);
 
 	ksp->ks_update = update_rxq_kstats;
 	ksp->ks_private = (void *)rxq;
@@ -3541,7 +3894,6 @@ update_rxq_kstats(kstat_t *ksp, int rw)
 	KS_U_FROM(rxcsum, rxq);
 	KS_U_FROM(rxpkts, rxq);
 	KS_U_FROM(rxbytes, rxq);
-	KS_U_FROM(nomem, rxq);
 
 	return (0);
 }
@@ -3661,20 +4013,14 @@ rxbuf_cache_create(struct rxbuf_cache_params *p)
 	    rxbuf_ctor, rxbuf_dtor, NULL, p, NULL, 0);
 }
 
-/*
- * If ref_cnt is more than 1 then those many calls to rxbuf_free will
- * have to be made before the rxb is released back to the kmem_cache.
- */
 static struct rxbuf *
-rxbuf_alloc(kmem_cache_t *cache, int kmflags, uint_t ref_cnt)
+rxbuf_alloc(kmem_cache_t *cache, int kmflags)
 {
 	struct rxbuf *rxb;
 
-	ASSERT(ref_cnt > 0);
-
 	rxb = kmem_cache_alloc(cache, kmflags);
 	if (rxb != NULL) {
-		rxb->ref_cnt = ref_cnt;
+		rxb->ref_cnt = 1;
 		rxb->cache = cache;
 	}
 
diff --git a/usr/src/uts/intel/cxgbe/t4nex/Makefile b/usr/src/uts/intel/cxgbe/t4nex/Makefile
index 5353461f36..eda61150f1 100644
--- a/usr/src/uts/intel/cxgbe/t4nex/Makefile
+++ b/usr/src/uts/intel/cxgbe/t4nex/Makefile
@@ -13,7 +13,7 @@
 # Copyright (c) 2013 by Chelsio Communications, Inc. All rights reserved.
 #
 # Copyright (c) 2018, Joyent, Inc.
-# Copyright 2023 Oxide Computer Company
+# Copyright 2025 Oxide Computer Company
 
 #
 # This makefile drives the production of the Chelsio Terminator 4 10G Ethernet
@@ -53,8 +53,11 @@ CFLAGS += -I$(UTSBASE)/common/io/cxgbe -I$(UTSBASE)/common/io/cxgbe/common \
 #
 LDFLAGS += -N misc/mac -N drv/ip
 
-# needs work
-SMOFF += all_func_returns,snprintf_overflow
+# "common" code is still not smatch clean
+T4NEX_SMOFF_OBJS	= t4_hw.o cudbg_lib.o cudbg_wtp.o cudbg_flash_utils.o \
+			fastlz_api.o
+T4NEX_SMOFF_PATHS	= $(T4NEX_SMOFF_OBJS:%=$(OBJS_DIR)/%)
+$(T4NEX_SMOFF_PATHS)	:= SMOFF += all_func_returns
 
 #
 # Default build targets.
-- 
2.51.2

